# -*- coding: utf-8 -*-

import numpy, matplotlib.pyplot


# Définition de la fonction

def fonction (x) :
    return 3.56995*x*(1-x)


# Construction du graphe de la fonction (non affiché)
# Fonction : fonction dont on trace le graphe
# X_Min, X_Max : abscisses extrémales de la fenêtre de visualisation
# Sortie : prépare le graphe de la fonction, sans l'afficher.

def graphe_fonction (Fonction, X_Min, X_Max) :
    Resolution = 1000
    Step = (X_Max-X_Min) / Resolution
    Range = numpy.arange(X_Min, X_Max, Step)
    Image = fonction(Range)
    matplotlib.pyplot.clf()
    matplotlib.pyplot.axis([X_Min, X_Max, X_Min, X_Max])
    matplotlib.pyplot.gca().set_aspect('equal', adjustable='box')
    matplotlib.pyplot.plot(Range, Image, 'b-', linewidth=0.5)
    matplotlib.pyplot.plot(Range, Range, 'k-', linewidth=0.5)


# Construction et affichage d'une ligne brisée
# CourbePolygonale : liste des coordonnées des points que l'on va relier entre eux
# Sortie : affiche la courbe polygonale.

def suite_araignee (CourbePolygonale) :
    matplotlib.pyplot.plot([x[0] for x in CourbePolygonale], [x[1] for x in CourbePolygonale], 'r-', alpha=0.7, linewidth=0.5)
    matplotlib.pyplot.show()


# Construction de la toile d'araignée

Iteration = 50
x = numpy.random.uniform(0,1)

# On peut enlever les premiers termes de la suite pour mieux voir sa périodicité (ou plus généralement l'attracteur).
# Par exemple, pour enlever les 100 premiers termes de la suite, décommenter les trois lignes suivantes :
# 
# for n in range(100):
#     x = fonction(x)
                  
Toile = []
Toile.append((x,0))
for n in range(Iteration):
    y = fonction(x)
    Toile.append((x,x))
    Toile.append((x,y))
    x = y


# Affichage du diagramme en toile d'araignée.
# Appeler d'abord graphe_fonction pour préparer le graphe, puis suite_araignee pour ajouter la courbe polygonale et l'afficher.

graphe_fonction(fonction, 0, 1)
suite_araignee(Toile)
