# -*- coding: utf-8 -*-

import numpy
from decimal import *
getcontext().prec = 110


# Définition de la fonction

def fonction (x) :
    return Decimal(numpy.sqrt(6))*x*(1-x)


# Définition de l'algorithme de seuil
# Valeur : valeur initiale de la suite
# Seuil : seuil en-dessous duquel l'algorithme s'arrête et ressort la valeur de la suite. Variable de type Decimal.
# Afin d'éviter les boucles infinies, on utilise directement un boucle For et non une boucle While
# Attention : le seuil ne doit pas être plus petit que la précision des nombres de Type Decimal (ici, 10**(-110))

def algorithme_seuil (Valeur, Seuil) :
    x = Valeur
    Iterations = 1000
    for n in range(Iterations) :
        y = fonction(x)
        if abs(y-x) < Seuil :
            return "Valeur trouvée : " + str(y) + ". \n Il a fallu " + str(n+1) + " itérations."
        x = y
    return "Après " + str(Iterations) + " itérations, l'algorithme n'a pas convergé au seuil voulu."


# Exemple d'application de cet algorithme

Valeur = Decimal(0.1)
Seuil = Decimal(10)**(-100)

print( algorithme_seuil(Valeur, Seuil) )
